"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeView = void 0;
const documenter_ui_heading_1 = require("@teambit/documenter.ui.heading");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const documenter_ui_code_snippet_1 = require("@teambit/documenter.ui.code-snippet");
const code_ui_queries_get_file_content_1 = require("@teambit/code.ui.queries.get-file-content");
const prism_light_1 = __importDefault(require("react-syntax-highlighter/dist/esm/prism-light"));
const markdown_1 = __importDefault(require("react-syntax-highlighter/dist/esm/languages/prism/markdown"));
const base_ui_constants_storage_1 = require("@teambit/base-ui.constants.storage");
const code_view_module_scss_1 = __importDefault(require("./code-view.module.scss"));
prism_light_1.default.registerLanguage('md', markdown_1.default);
function CodeView({ className, componentId, currentFile, icon }) {
    const { fileContent, loading } = code_ui_queries_get_file_content_1.useFileContent(componentId, currentFile);
    const title = react_1.useMemo(() => currentFile === null || currentFile === void 0 ? void 0 : currentFile.split('/').pop(), [currentFile]);
    const lang = react_1.useMemo(() => {
        const langFromFileEnding = currentFile === null || currentFile === void 0 ? void 0 : currentFile.split('.').pop();
        // for some reason, SyntaxHighlighter doesnt support scss or sass highlighting, only css. I need to check how to fix this properly
        if (langFromFileEnding === 'scss' || langFromFileEnding === 'sass')
            return 'css';
        if (langFromFileEnding === 'mdx')
            return 'md';
        return langFromFileEnding;
    }, [fileContent]);
    if (!fileContent && !loading && currentFile)
        return react_1.default.createElement(EmptyCodeView, null);
    return (react_1.default.createElement("div", { className: classnames_1.default(code_view_module_scss_1.default.codeView, className) },
        react_1.default.createElement(documenter_ui_heading_1.H1, { size: "sm", className: code_view_module_scss_1.default.fileName },
            currentFile && react_1.default.createElement("img", { className: code_view_module_scss_1.default.img, src: icon }),
            react_1.default.createElement("span", null, title)),
        react_1.default.createElement(documenter_ui_code_snippet_1.CodeSnippet, { className: code_view_module_scss_1.default.codeSnippetWrapper, frameClass: code_view_module_scss_1.default.codeSnippet, showLineNumbers: true, language: lang }, fileContent || '')));
}
exports.CodeView = CodeView;
function EmptyCodeView() {
    return (react_1.default.createElement("div", { className: code_view_module_scss_1.default.emptyCodeView },
        react_1.default.createElement("img", { src: `${base_ui_constants_storage_1.staticStorageUrl}/harmony/empty-code-view.svg` }),
        react_1.default.createElement("div", null, "Nothing to show")));
}
//# sourceMappingURL=code-view.js.map